<?php
/**
Usage : /utorrent_control.php ip=IP port=PORT user=USER pass=PASS action=ACTION

Where : IP: Server Ip address where uTorrent is running. 
        PORT: uTorrent WebUI port. 
        USER: WebUI access user. 
        PASS: WebUI access password. 
        ACTION: Should be one of these values : start | stop | pause | unpause | speeds
        
Actions : start : Start all torrents. 
          stop : Stop all torrents. 
          pause : Pause all torrents. 
          unpause : Unpause all torrents. 
          speeds : Return a string with Global upload/download speeds and number of leechers/seeders. Format : DL: xxx Ko/s (nn) UL: yyy Ko/s (mm)
**/
  
if (isset($argv)) {
    foreach ($argv as $arg) {
        $argList = explode('=', $arg);
        if (isset($argList[0]) && isset($argList[1])) {
                $_GET[$argList[0]] = $argList[1];
        }
    }
}

$action = array("start", "stop", "pause", "unpause", "speeds");

if (isset($_GET['ip']) and isset($_GET['port']) and isset($_GET['user']) and isset($_GET['pass']) and isset($_GET['action']) and in_array($_GET['action'],$action))
{
    $main=Array($_GET['ip'],$_GET['port'],'gui',$_GET['user'],$_GET['pass']); // ip, port, path (leave at gui!), username, password
    $token_main=webui($main,'token.html');
    $list_main=webui($main,'?list=1&token='.$token_main);
    $RESULT = "OK";

    if ($list_main[0] == false)
    {
      $RESULT = $list_main[1];
    } else {
		if ($_GET['action'] == "speeds")
		{
			$ULSPEED = 0;
			$ULNB = 0;
			$DLSPEED = 0;
			$DLNB = 0;
			foreach ($list_main[1]['torrents'] as $torrent)
			{
			  if ($torrent[8] > 0) {
				$ULSPEED = $ULSPEED + $torrent[8];
				$ULNB = $ULNB + 1;
			  }
			  if ($torrent[9] > 500) {
				$DLSPEED = $DLSPEED + $torrent[9];
				$DLNB = $DLNB + 1;            
			  }
			}
			$ULSPEED = round ($ULSPEED / 1000 , 2);
			$DLSPEED = round ($DLSPEED / 1000 , 2);
			$RESULT = "DL: ".$DLSPEED." Ko/s (".$DLNB.")<br />UL: ".$ULSPEED." Ko/s (".$ULNB.")";
		} else {
				foreach ($list_main[1]['torrents'] as $torrent)
				{
				  $rem_main=webui($main,'?action='.$_GET['action'].'&token='.$token_main.'&hash='.$torrent[0]);
				  if (is_array($rem_main) && $rem_main[0] == false)
				  {
					$RESULT=$RESULT."[".$rem_main[1]."]";
				  }
				}
		}
    }
} else {
    $RESULT = 'ERROR : ip, port, user, pass, action arguments are mandatory !';
}
echo $RESULT;
exit;

function webui ($client, $request, $file = null)
{
    $url='http://'.$client[0].':'.$client[1].'/'.$client[2].'/'.$request;
    $curl_opts=Array(
        CURLOPT_FRESH_CONNECT => 1,
        CURLOPT_FORBID_REUSE => 1,
        CURLOPT_USERPWD => $client[3].':'.$client[4],
        CURLOPT_HEADER => 0,
        CURLOPT_RETURNTRANSFER => 1,
        CURLOPT_URL => $url,
        CURLOPT_SSL_VERIFYPEER => FALSE,
        CURLOPT_FOLLOWLOCATION => 1,
        CURLOPT_COOKIEFILE => 'cookiejar.tmp',
        CURLOPT_COOKIEJAR => 'cookiejar.tmp'
    );
    if ( !empty($file) )
    {
        if ( !file_exists($file) )
        {
            return(Array(false,'No such torrent file: '.$file));
        }
        $curl_opts[CURLOPT_POSTFIELDS]['torrent_file']='@'.$file;
    }
    $ch = curl_init();
    curl_setopt_array($ch, $curl_opts);
    $results = curl_exec ($ch);
    if ( curl_errno($ch) !== 0 )
    {
        if ( curl_errno($ch) === 52 )
        {
            return(Array(false,'Blocked by ipfilter.dat OR cURL error: '.curl_error($ch).' ('.curl_errno($ch).')'));
        }
        else
        {
            return(Array(false,'cURL error: '.curl_error($ch).' ('.curl_errno($ch).')'));
        }
    }
    switch (curl_getinfo($ch,CURLINFO_HTTP_CODE))
    {
    case 404:
        return(Array(false,'File not found.'));
    case 401:
        return(Array(false,'Wrong login details.'));
    case 300:
        return(Array(false,'Invalid request.'));
    case 200:
        if ( $request == 'token.html' )
        {
            preg_match("/<div[^>]*id=[\"']token[\"'][^>]*>([^<]*)<\/div>/",$results,$matches);
            return($matches[1]);
        }
        $json=json_decode($results,true);
        if ( $json !== false && count($json) > 0 ) 
        {
            return(Array(true,$json));
        }
        return(Array(false,'Invalid JSON'));
    default:
        return(Array(false,'Invalid response code '.curl_getinfo($ch,CURLINFO_HTTP_CODE)."\r\n".$results));
    }
    curl_close ($ch);
    unset($ch);
}
?>